moSetGetMohPDA = {};

function moSetGetMohPDA:setLine(self, selectLine, insertLine, replaceLine, newLine, copyLine, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_"
	if newLine ~= nil then		
		table.insert(moSetGetOverlays.pda[whichSubPDA].line, selectLine+1, {view=false; appsAtLine=0; appSelect=1; appSettingSelect=1; app={}});
		moSetGetMohPDA:setAppAtLine(self, selectLine+1, 0, nil, nil, true, nil, whichSubPDA); --set automatic first App at new line
		--moSetGetOverlays.pda[whichSubPDA].line[#moSetGetOverlays.pda[whichSubPDA].line+1] = {view=false; appsAtLine=0; appSelect=1; appSettingSelect=1; app={}};
		return true;
	elseif insertLine ~= nil then
		--table.insert(moSetGetOverlays.pda[whichSubPDA].line, selectLine+1, {view=false; appsAtLine=0; appSelect=1; appSettingSelect=1; app={}});
	end;
	return false;
end;

function moSetGetMohPDA:deleteLine(selectLine, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_"
	table.remove(moSetGetOverlays.pda[whichSubPDA].line, selectLine);
	return true;
end;

function moSetGetMohPDA:setAppAtLine(self, selectLine, selectApp, insertApp, replaceApp, newApp, copyApp, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_"
	if moSetGetOverlays.pda[whichSubPDA].line[selectLine].app ~= nil then
		if (not moGeneralSettings.ignore.maxAppsAtLine and #moSetGetOverlays.pda[whichSubPDA].line[selectLine].app+1 > moSetGetOverlays.pda[whichSubPDA].maxAppsAtLine) or moSetGetOverlays.pda[whichSubPDA].line[selectLine].appsAtLine >= 50 then g_currentMission:showBlinkingWarning("limit has been reached", 1000);return false;end;
	end;
	if insertApp ~= nil then
	
	elseif newApp ~= nil then
		--moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp+1] = {iconTyp=0; icon=0, iconName="", cmd={}};
		if moSetGetOverlays.pda[whichSubPDA].line[selectLine].app == nil then 
			moSetGetOverlays.pda[whichSubPDA].line[selectLine].app = {};
			table.insert(moSetGetOverlays.pda[whichSubPDA].line[selectLine].app, 1, {iconTyp=0; icon=0, iconName="", cmd={}, openMarker=false});
		--elseif #moSetGetOverlays.pda[whichSubPDA].line[selectLine].app < 1 then
			--table.insert(moSetGetOverlays.pda[whichSubPDA].line[selectLine].app, 1, {iconTyp=0; icon=0, iconName="", cmd={}});
		else
			table.insert(moSetGetOverlays.pda[whichSubPDA].line[selectLine].app, selectApp+1, {iconTyp=0; icon=0, iconName="", cmd={}, openMarker=false});
		end;
		moSetGetOverlays.pda[whichSubPDA].line[selectLine].appsAtLine = moSetGetOverlays.pda[whichSubPDA].line[selectLine].appsAtLine+1;
		return true;
	end;
	return false;
end;

function moSetGetMohPDA:deleteAppAtLine(selectLine, selectApp, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_"
	if selectLine == moSetGetOverlays.pda[whichSubPDA].appMouseSelect.line then
		if moSetGetOverlays.pda[whichSubPDA].line[selectLine].appsAtLine > 1 and moSetGetOverlays.pda[whichSubPDA].line[selectLine].app ~= nil then
			table.remove(moSetGetOverlays.pda[whichSubPDA].line[selectLine].app, selectApp);
			--moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp] = nil;
			moSetGetOverlays.pda[whichSubPDA].line[selectLine].appsAtLine = moSetGetOverlays.pda[whichSubPDA].line[selectLine].appsAtLine-1;
			moSetGetOverlays.pda[whichSubPDA].line[selectLine].appSelect = 1;
			moSetGetOverlays.pda[whichSubPDA].line[selectLine].appSettingSelect = 1;
			if moSetGetOverlays.pda[whichSubPDA].line[selectLine].appsAtLine == 1 then
				--moSetGetOverlays.pda[whichSubPDA].line[selectLine].app = {};
			end;
			return true;
		elseif moSetGetOverlays.pda[whichSubPDA].line[selectLine].appsAtLine == 1 then
			g_currentMission:showBlinkingWarning("This App (1) can not be deleted\nDelete this Line", 2000);
			return false;
		end;
	end;
	return false;
end;

function moSetGetMohPDA:resetRenderViewLines(whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_"
	moSetGetOverlays.pda[whichSubPDA].renderViewLines = {};
	for a=1, #moSetGetOverlays.pda[whichSubPDA].line do
		moSetGetOverlays.pda[whichSubPDA].line[a].view = false;	
	end;
	--is viewLines > renderViewLines then set new		
	if moSetGetOverlays.pda[whichSubPDA].viewLines > #moSetGetOverlays.pda[whichSubPDA].line then
		moSetGetOverlays.pda[whichSubPDA].viewLines = #moSetGetOverlays.pda[whichSubPDA].line;
	end;
	for a=1, moSetGetOverlays.pda[whichSubPDA].viewLines do				
		table.insert(moSetGetOverlays.pda[whichSubPDA].renderViewLines, #moSetGetOverlays.pda[whichSubPDA].renderViewLines+1, a);
	end;
	for a=1, #moSetGetOverlays.pda[whichSubPDA].renderViewLines do
		moSetGetOverlays.pda[whichSubPDA].line[moSetGetOverlays.pda[whichSubPDA].renderViewLines[a]].view = true;	
	end;
	moSetGetOverlays:replacePdaPosY(self, whichSubPDA);	
end;

function moSetGetMohPDA:resetKeyAndAppMouseSelect(keySelect, appMouseSelect, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_"
	if keySelect then
		moSetGetOverlays.pda[whichSubPDA].keySelect.line = 1;
		moSetGetOverlays.pda[whichSubPDA].keySelect.app = 1;
		moSetGetOverlays.pda[whichSubPDA].keySelect.pda = 1;
	end;
	if appMouseSelect then
		moSetGetOverlays.pda[whichSubPDA].appMouseSelect.line = 1;
		moSetGetOverlays.pda[whichSubPDA].appMouseSelect.app = 1;
		moSetGetOverlays.pda[whichSubPDA].appMouseSelect.pda = 1;
		tabletPdaDefaultSide3:appCmdTableHidden(whichSubPDA);
	end;
end;

function moSetGetMohPDA:setKeyAndAppMouseSelect(lineSelect, appSelect, keySelect, appMouseSelect, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_"
	if keySelect then
		moSetGetOverlays.pda[whichSubPDA].keySelect.line = lineSelect;
		moSetGetOverlays.pda[whichSubPDA].keySelect.app = appSelect;
		moSetGetOverlays.pda[whichSubPDA].keySelect.pda = 1;
	end;
	if appMouseSelect then
		moSetGetOverlays.pda[whichSubPDA].appMouseSelect.line = lineSelect;
		moSetGetOverlays.pda[whichSubPDA].appMouseSelect.app = appSelect;
		moSetGetOverlays.pda[whichSubPDA].appMouseSelect.pda = 1;
		tabletPdaDefaultSide3:appCmdTableHidden(whichSubPDA);
	end;
end;

function moSetGetMohPDA:getAppMouseSelect(lineSelect, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_"
	if moSetGetOverlays.pda[whichSubPDA].appMouseSelect.line == lineSelect then
		return true, moSetGetOverlays.pda[whichSubPDA].appMouseSelect.app;
	end;
	return false, moSetGetOverlays.pda[whichSubPDA].appMouseSelect.line;
end;

function moSetGetMohPDA:getLineMouseSelect(whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_";
	return moSetGetOverlays.pda[whichSubPDA].appMouseSelect.line;	
end;

--mod open Pda Normal
function moSetGetMohPDA.openPDA(whichPDA, openPda) --over PDA Cmd
	local whichSubPDA = whichPDA or "masterPDA_"
	if openPda ~= nil and openPda then		
		if moSetGetOverlays.pda[whichSubPDA] ~= nil and not moSetGetOverlays.pda[whichSubPDA].isOpen then moSetGetOverlays.pda[whichSubPDA].isOpen = true;end;		
		if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil) then
			g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage = {masterPage=3, slavePage=1, pageSide=1};
		end;
	end;
end;
--mod open Pda Normal

--mod close Pda Normal
function moSetGetMohPDA.closePDA(whichPDA, closePda) --over PDA close button (moMouseKeyMohPDA action)(delete PDA)
	local whichSubPDA = whichPDA or "masterPDA_"
	if closePda ~= nil and closePda then
		if whichSubPDA == "masterPDA_" then g_currentMission:showBlinkingWarning("Master PDA can not Closed", 2500);return;end;
		if moSetGetOverlays.pda[whichSubPDA] ~= nil and moSetGetOverlays.pda[whichSubPDA].isOpen then moSetGetOverlays.pda[whichSubPDA].isOpen = false;end;
		--if guiMenueSettings:isSelectPageGlobalName(self, whichSubPDA) then --reset open settings page (isopen and select)
		if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil) then
			g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage = {masterPage=3, slavePage=1, pageSide=1};
		end;
	end;
end;
--mod close Pda Normal

--mod open/close Settings Side 1 by globalName
function moSetGetMohPDA.setOpenCloseSettingsPDA(whichPDA, openSettingsPda, closeSettingsPda) --over PDA Settings Button or/and from Callback transfer	
	if not g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].isGenerate then MultiOverlayV3.guiMenue.on = nil;return;end;
	local whichSubPDA = whichPDA or "masterPDA_";
	local openMasterPage, _, _ = g_currentMission.guiMenue.master.getPageNumberByPageGlobalName(MultiOverlayV3.guiMenue.modTable, "tabletPDAs_");
	if openMasterPage ~= nil and openMasterPage ~= 0 and openMasterPage ~= g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastOpenPage.masterPage then g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastOpenPage.masterPage = openMasterPage;end;
	local newPage = 1;	
	local lastMasterPage = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastOpenPage.masterPage;
	local lastSlavePage = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastOpenPage.slavePage;
	local lastPageSide = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastOpenPage.pageSide;
	local modPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page;	
	local pageType = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[lastMasterPage].pageType;
	if pageType == "modSlavePageSide" then modPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[lastMasterPage].page;end;	
	if modPageTable ~= nil then		
		--open new settings pda
		if openSettingsPda and moSetGetOverlays.pda[whichSubPDA] ~= nil then
			if moSetGetOverlays.pda[whichSubPDA].autoOpenCloseSelectSettings then		
				for a=1, #modPageTable do
					if modPageTable[a].globalName == whichSubPDA and string.len(modPageTable[a].globalName) == string.len(whichSubPDA) then newPage = a;break;end;
				end;			
				g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastOpenPage.pageSide = 1
				moSetGetOverlays.pda[whichSubPDA].isOpen = true;
				tabletPdaDefaultSide3:appCmdTableHidden(whichSubPDA);
				if pageType == "modSlavePageSide" then g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastOpenPage.slavePage = newPage or 1;else
				g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastOpenPage.masterPage = newPage or 1;end;				
			end;
		end;
		--open new settings pda
		--close old settings pda
		if openSettingsPda and closeSettingsPda == nil and ((pageType ~= "modSlavePageSide" and tonumber(newPage) ~= tonumber(lastMasterPage)) or (pageType == "modSlavePageSide" and tonumber(newPage) ~= tonumber(lastSlavePage))) then
			whichSubPDA = modPageTable[lastMasterPage].globalName;
			if pageType == "modSlavePageSide" then whichSubPDA = modPageTable[lastSlavePage].globalName;end;
			if whichSubPDA ~= "masterPDA_" then
				if moSetGetOverlays.pda[whichSubPDA] ~= nil and moSetGetOverlays.pda[whichSubPDA].autoOpenCloseSelectSettings then
					moSetGetOverlays.pda[whichSubPDA].isOpen = false;
				end;
			end;
			return;
		end;
		--close old settings pda
		--close all pda is Settings Global or
		if closeSettingsPda ~= nil and not closeSettingsPda then		
			for pda, v in pairs (moSetGetOverlays.pda) do			
				if pda ~= "masterPDA_" then
					if moSetGetOverlays.pda[pda].isOpen and moSetGetOverlays.pda[pda].autoOpenCloseSelectSettings then moSetGetOverlays.pda[pda].isOpen = false;end;
				end;
			end;
		end;
		--close all pda is Settings Global or
		--close all Settings pda is Settings Close/reset
		if closeSettingsPda ~= nil and closeSettingsPda then
			for pda, v in pairs (moSetGetOverlays.pda) do
				if pda ~= "masterPDA_" then
					if moSetGetOverlays.pda[pda].isOpen and moSetGetOverlays.pda[pda].autoClose then moSetGetOverlays.pda[pda].isOpen = false;elseif not moSetGetOverlays.pda[pda].isOpen and not moSetGetOverlays.pda[pda].autoClose then moSetGetOverlays.pda[pda].isOpen = true;end;				
				end;
			end;
		end;
		--close all Settings pda is Settings Close/reset
	end;		
end;
--mod open/close Settings Side 1 by globalName


function moSetGetMohPDA:editIconText(whichPDA, iconName)
	local whichSubPDA = whichPDA or "masterPDA_";
	local modAppValues = {
		dialogTitel=tostring(MultiOverlayV3.metadata.title); 
		dialogText2="Edit Icon Text (is Testphase)";		
		onSaveCallback=moSetGetMohPDA.saveEditIconText;
		checkText = {inputTextAppendEnd="", maxLengthText=15, minLengthText=1};
		ownValues = {whichSubPDA, iconName};
		visibleButton = {saveButton=true, checkButton=false};
	};
	return g_currentMission.guiMenue.guiSetGet:openLsOrGuiMenueDialog("GuiMenueInOutPutTextDialog", modAppValues);
end;

function moSetGetMohPDA.saveEditIconText(...)
	if ... ~= nil and type(...) == "table" then
		local args = ...;				
		if args.inputText ~= nil and string.len(args.inputText) >= 1 then			
			g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].tempSave = true;			
			moSetGetOverlays.appIcon[args.ownValues[1]][args.ownValues[2]].typTable["typ4"].txt = tostring(args.inputText);
		end;		
	end;
	g_currentMission.guiMenue.guiSetGet:closeLsOrGuiMenueDialog(); --->reset other next Mods not start Dialog
end;

function moSetGetMohPDA:getPDAs()	
	local mohPDAs = {};
	if moSetGetOverlays.pda ~= nil then		
		for whichPDA, value in pairs(moSetGetOverlays.pda) do				
			mohPDAs[#mohPDAs+1] = {tostring(whichPDA), Utils.getNoNil(moSetGetOverlays.pda[whichPDA].name, "")};
		end;		
	end;
	return mohPDAs;
end;

function moSetGetMohPDA:getOpenPDAs()	
	local openAreas = {};
	if moSetGetOverlays.pda ~= nil then --and #moSetGetOverlays.pda > 0 then
		--print("Begin")
		for key, value in pairs(moSetGetOverlays.pda) do				
			if value.isOpen then
				openAreas[#openAreas+1] = tostring(key);				
			end;
		end;
		--print("End")		
	end;
	return openAreas;
end;