moBunkerSilosConfig = {};


function moBunkerSilosConfig:onStartMission()
	moBunkerSilos:load();
end;

function moBunkerSilosConfig:defaultValues()
	moBunkerSilos.values = {bunkersilos={}, updateTimer=10, msec=false};
end;

function moBunkerSilosConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex)
	if moBunkerSilos.values == nil then moBunkerSilosConfig:defaultValues();end;
	local groupNameTag = (xmlNameTag.. ".module.bunkersilos(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		moBunkerSilos.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	end;
	if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		moBunkerSilos.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	end;
end;

function moBunkerSilosConfig:saveXml(self, Xml, xmlNameTag)
	if moBunkerSilos.values == nil then moBunkerSilosConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.bunkersilos(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moBunkerSilos.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moBunkerSilos.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moBunkerSilosConfig.onSaveCallback()
	moSetGetClientSettings:saveConfig(self);
end;

