moGreenhousesConfig = {};

function moGreenhousesConfig:onStartMission()
	moGreenhouses:load();	
end;

function moGreenhousesConfig:defaultValues()
	moGreenhouses.values = {greenhouses={}, updateTimer=60, msec=false};
end;

function moGreenhousesConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex)
	if moGreenhouses.values == nil then moGreenhousesConfig:defaultValues();end;
	local groupNameTag = (xmlNameTag.. ".module.greenhouses(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		moGreenhouses.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	end;
	if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		moGreenhouses.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	end;	
end;

function moGreenhousesConfig:saveXml(self, Xml, xmlNameTag)
	if moGreenhouses.values == nil then moGreenhousesConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.greenhouses(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moGreenhouses.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moGreenhouses.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moGreenhousesConfig.onSaveCallback()
	moSetGetClientSettings:saveConfig(self);
end;